#ifndef _KGR_PATCH_BSC1133191_X86_GUP_H
#define _KGR_PATCH_BSC1133191_X86_GUP_H

#ifdef CONFIG_X86_64

int kgr_patch_bsc1133191_x86_gup_init(void);
static inline void kgr_patch_bsc1133191_x86_gup_cleanup(void) {}


struct page;

int kgr_gup_pte_range(pmd_t pmd, unsigned long addr,
		unsigned long end, int write, struct page **pages, int *nr);

int kgr_gup_huge_pmd(pmd_t pmd, unsigned long addr,
		unsigned long end, int write, struct page **pages, int *nr);

int kgr_gup_huge_pud(pud_t pud, unsigned long addr,
		unsigned long end, int write, struct page **pages, int *nr);

#define KGR_PATCH_BSC1133191_X86_GUP_FUNCS			\
	KGR_PATCH(gup_pte_range, kgr_gup_pte_range),		\
	KGR_PATCH(gup_huge_pmd, kgr_gup_huge_pmd),		\
	KGR_PATCH(gup_huge_pud, kgr_gup_huge_pud),		\

#else /* CONFIG_X86_64 */

static inline int kgr_patch_bsc1133191_x86_gup_init(void) { return 0; }
static inline void kgr_patch_bsc1133191_x86_gup_cleanup(void) {}

#define KGR_PATCH_BSC1133191_X86_GUP_FUNCS

#endif /* CONFIG_X86_64 */

#endif /* _KGR_PATCH_BSC1133191_X86_GUP_H */
